/* Copyright 2010 ESRI
* 
* All rights reserved under the copyright laws of the United States
* and applicable international laws, treaties, and conventions.
* 
* You may freely redistribute and use this sample code, with or
* without modification, provided you include the original copyright
* notice and use restrictions.
* 
* See the use restrictions at http://help.arcgis.com/en/sdk/10.0/usageRestrictions.htm
* 
*/
package arcgissamples.symbologybean.commands;

import java.io.IOException;

import javax.swing.SwingUtilities;

import arcgissamples.symbologybean.ui.SymbologyFrame;

import com.esri.arcgis.beans.TOC.TOCBean;
import com.esri.arcgis.carto.IGeoFeatureLayer;
import com.esri.arcgis.carto.IGeoFeatureLayerProxy;
import com.esri.arcgis.controls.BaseCommand;
import com.esri.arcgis.controls.HookHelper;
import com.esri.arcgis.controls.IMapControl3;
import com.esri.arcgis.controls.IToolbarControl;

public class ShowSymbologyCommand extends BaseCommand {
	private static final long serialVersionUID = 1L;

	HookHelper hookHelper;

	IMapControl3 mapControl = null;
	TOCBean tocBean=null;

	public ShowSymbologyCommand(TOCBean tocBean) {
		caption = "Change Color Ramp";
		toolTip = "Launches the Symbology Dialog";
		enabled = true;
		this.tocBean=tocBean;
	}

	public void onCreate(Object obj) {
		try {
			hookHelper = new HookHelper();
			hookHelper.setHookByRef(obj);
			IToolbarControl tb = (IToolbarControl) hookHelper.getHook();
			mapControl = (IMapControl3) tb.getBuddy();
		} catch (IOException ex) {
			ex.printStackTrace();

		}
	}

	public void onClick() {
		// TODO Auto-generated method stub
		super.onClick();
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				try {
					Object obj = mapControl.getCustomProperty();
					IGeoFeatureLayer layer = new IGeoFeatureLayerProxy(obj);
					SymbologyFrame f = new SymbologyFrame(layer, hookHelper
							.getActiveView(), tocBean);
					f.setSize(575, 307);
					f.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

}
